--############################################
--Saw Blade V1.0
--Code by RabidToaster
--Awesome viewmodel by NeoDement
--############################################
--Settings - Edit these if you like!
	--Range of throw
		saw_range = 60000;
		saw_damage = 200;
--############################################
--Don't edit down here unless you know what you're doing.

	name = "Saw Blade"
	version = "1"
	subversion = "0"
	
	fullname = name.." V"..version.."."..subversion;
	classname = string.lower(string.gsub(name, " ", ""))..version..subversion;
	
	start = 0;
	delay = 0;
	h_offset = -0.2;
	t_offset = -0.4;
	
	function onInit( )
		_Msg("--------------------------------------------------------------\n");
		_Msg(fullname.."\n");
		_Msg("Primary fire - Melee attack with sawblade.\n");
		_Msg("Secondary fire - Throw sawblade.\n");
		_Msg("--------------------------------------------------------------\n");
		_EntPrecacheModel("models/props_junk/sawblade001a.mdl"); --Get the model ready
	end
	function onThink( )
		if start > 0 then
			if a_type == 1 and _CurTime() > start + delay + h_offset then
				start = 0;
				hit();
			end
			if a_type == 2 and _CurTime() > start + delay + t_offset then
				start = 0;
				throw();
			end
		end
	end
	--Custom functions
	function hit()
		_TraceLine(_PlayerGetShootPos(Owner), _PlayerGetShootAng(Owner), 50, Owner); --Look in front of the player
		if _TraceHit() == true then
			_PlaySoundPlayer(Owner, "physics/flesh/flesh_impact_bullet"..math.random( 3, 5 )..".wav");
			if _EntGetMoveType(_TraceGetEnt()) == 6 then
				phys.ApplyForceCenter (_TraceGetEnt(), vecMul (_EntGetRightVector(Owner), 10000))
			else
				_EntSetVelocity (_TraceGetEnt(), vecAdd(_EntGetVelocity (_TraceGetEnt()), vecMul (_EntGetRightVector(Owner), 100)))
			end
			_TraceAttack(_TraceGetEnt(), MyIndex, Owner, saw_damage); --If something is there, hurt it
		else
			_PlaySoundPlayer(Owner, "weapons/iceaxe/iceaxe_swing1.wav");
		end
	end
	function throw()
		local saw = _EntCreate("prop_physics") --Create an entity
		_EntSetModel(saw, "models/props_junk/sawblade001a.mdl"); --Set the model
		_EntSetKeyValue(saw, "onworldimpact", "stick"); --Make it stick in walls
		_EntSetPos(saw, vecSub(_PlayerGetShootPos(Owner), vector3(0, 0, 10))); --Position it in the hands
		_EntSetAng(saw, _PlayerGetShootAng(Owner)); --Angle it to the way the player is facing
		_EntSetOwner(saw, Owner) --Set the owner to the player
		_EntSpawn(saw); --Spawn it
		_EntitySetPhysicsAttacker(saw, Owner) --Kill credit goes to you
		_phys.ApplyForceCenter(saw, vecMul(_PlayerGetShootAng(Owner), vector3(saw_range, saw_range, saw_range))) --Make it fly!
                            _phys.ApplyTorqueCenter(saw, vector3(0,0,999999) ) --Make it spin too for zombie cutting
	end
	--End of custom functions
	function onPrimaryAttack( )
		if ( _PlayerInfo( Owner, "alive" ) == false ) then return; end	--Dead people can't use weapons
		delay = _PlayerViewModelSequence(Owner, ACT_VM_PRIMARYATTACK) --Play the animation
		start = _CurTime(); --Used for timer
		a_type = 1 --We're hitting this time
	end
	function onSecondaryAttack( )	
		if ( _PlayerInfo( Owner, "alive" ) == false ) then return; end	--Dead people can't use weapons
		delay = _PlayerViewModelSequence(Owner, ACT_VM_THROW) --Play the animation
		start = _CurTime(); --Used for timer
		a_type = 2 --We're throwing this time
	end
	function onReload( )
		return false;
	end
	function getWeaponSwapHands()
		return false;	
	end
	function getWeaponFOV()
		return 62;	
	end
	function getWeaponSlot()
		return 0;	
	end
	function getWeaponSlotPos()
		return 6;	
	end
	function getFiresUnderwater()
		return true;
	end
	function getReloadsSingly()
		return false;
	end
	function getDamage()
		return 0;
	end
	function getPrimaryShotDelay()
		return 1.5;
	end
	function getSecondaryShotDelay()
		return 2.7;
	end
	function getPrimaryIsAutomatic()
		return true;
	end
	function getSecondaryIsAutomatic()
		return false;
	end
	function getBulletSpread()
		return vector3( 0.0, 0.0, 0.0 );
	end
	function getViewKick()
		return vector3( 0.0, 0.0, 0.0);
	end
	function getViewKickRandom()
		return vector3( 0.0, 0.0, 0.0 );
	end
	function getViewModel()
		return "models/weapons/v_sawblade.mdl";
	end
	function getWorldModel()
		return "models/weapons/w_sawblade.mdl";
	end
	function getClassName()
		return classname;
	end
	function getPrimaryAmmoType()
		return "GaussEnergy";
	end
	function getSecondaryAmmoType()
		return "GaussEnergy";
	end
	function getMaxClipPrimary()
		return -1;
	end
	function getMaxClipSecondary()
		return -1;
	end
	function getDefClipPrimary()
		return 0;
	end
	function getDefClipSecondary()
		return 1;
	end
	function getAnimPrefix()
		return "phys";
	end
	function getPrintName()
		return fullname;
	end
	function getPrimaryScriptOverride()
		return 3;
	end
	function getSecondaryScriptOverride()
		return 3;
	end
	function getDeathIcon()
		return "sawblade";
	end
	function getHUDMaterial( )		
                            return "gmod/SWEP/sawblade";	
              end